<?php
// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if ( !defined('PHPWG_ROOT_PATH')) 
{
  die('Hacking attempt!');
}

if (!defined('MAIL_SUPERV_PATH')) define('MAIL_SUPERV_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');


// +-----------------------------------------------------------------------+
// | Check Access and exit when user status is not ok                      |
// +-----------------------------------------------------------------------+
//check_status(ACCESS_ADMINISTRATOR);

global $user, $lang, $conf, $errors,$mails_donnes;
global $args, $conf_mail,$infos_message,$erreur_message,$mails_options ;


include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');


include_once (MAIL_SUPERV_PATH.'include/constants.php'); 
include_once (MAIL_SUPERV_PATH.'include/fonctions.php'); 
include_once (PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
$my_base_url = get_admin_plugin_menu_link(__FILE__);



 load_language('plugin.lang', MAIL_SUPERV_PATH);

 

$mails_options = explode("," , $conf['mail_superv']);


if (count($mails_options) < 6 )
{
$mails_options[]='off';

}
if (count($mails_options) < 7 )
{
$mails_options[]='';

}

$mails_donnes=Get_Datas();

	if (!isset($_GET['tab']))
	$page['tab'] = 'mail_superv_admin';
else
  $page['tab'] = $_GET['tab'];

 $icon_path = 'template/yoga/icon/help.png';

$tabhelp=  '  <img src="'.PHPWG_ROOT_PATH. $icon_path .'" class="button" alt="(?)"> ';

 

$tabsheet = new tabsheet();
$tabsheet->add('mail_superv_admin',
               l10n('Tab_set'),
               $my_base_url.'&amp;tab=mail_superv_admin');
			   
$tabsheet->add('mail_superv_test',
               l10n('Tab_test'),
               $my_base_url.'&amp;tab=mail_superv_test');
			   
$tabsheet->add( 'mail_black_liste',
               l10n('blackliste'),
			   $my_base_url.'&amp;tab=mail_black_liste');
 
			   			   
$tabsheet->add('mail_superv_help',$tabhelp
              ,
               $my_base_url.'&amp;tab=mail_superv_help');
			   
			   
$tabsheet->select($page['tab']);
$tabsheet->assign();

$page['global'] = array();
$error = array();

vrif_base();

$aff_nb=true;


// *************************************************************************
// |                          Slection de l'onglet                        |
// *************************************************************************

	 	$modif=false ;


//================================================================================
switch ($page['tab'])
 {
   
// *************************************************************************
//                         initialisation                                  |
// *************************************************************************
  case 'mail_superv_admin':

//=============================================================
if ( isset($_POST['refresh']) ) {
   	 	
	if ($mails_donnes['nb_mails'] == 0 )  
	    $mails_donnes['date_mail'] = time();	
	
	if ($mails_donnes['nb_spams'] == 0 )
	   $mails_donnes['date_spam'] = time();
	
	
	if ($mails_donnes['quarantaine'] == false)
	{ $mails_donnes['reste'] = 0;
	  $mails_donnes['date_quarantaine']=time();
	 }
     sauve_donnes();
 	$erreur_message .="<DIV  > <input name='' type='checkbox' value='' /> </DIV>" ;
 	$aff_nb = false ;
 
	}

if ( isset($_POST['raz']) ) {
	$mails_donnes['date_quarantaine']=time();
	$mails_donnes['nb_mails'] = 0  ;
	$mails_donnes['nb_spams'] = 0  ;
	$mails_donnes['date_mail'] = time();
	$mails_donnes['date_spam'] = time();
	
	$mails_donnes['reste'] = 0;
	$mails_donnes['quarantaine']='false';
	
     sauve_donnes();
	 $infos_message .=  l10n('save_config') ;
	}
	
if ( isset($_POST['submit']) )
{
//Options
  $mails_options[0] = isset($_POST['check_mailto']) ? $_POST['check_mailto'] : '' ;
  $mails_options[1] = isset($_POST['check_header_carbon']) ? $_POST['check_header_carbon'] : '' ;
  $mails_options[2] = isset($_POST['check_header_text']) ? $_POST['check_header_text'] : '' ;

  
//donnes  
$mails_donnes['nb_mails_maxi'] = isset($_POST['nb_mails_maxi']) ? $_POST['nb_mails_maxi'] :  $mails_donnes['nb_mails_maxi']  ;
$mails_donnes['nb_mails_periode'] = isset($_POST['nb_mails_periode']) ? $_POST['nb_mails_periode'] :  $mails_donnes['nb_mails_periode']  ;
$mails_donnes['nb_spams_maxi'] = isset($_POST['nb_spams_maxi']) ? $_POST['nb_spams_maxi'] :  $mails_donnes['nb_spams_maxi']  ;
$mails_donnes['nb_spams_periode'] = isset($_POST['nb_spams_periode']) ? $_POST['nb_spams_periode'] :  $mails_donnes['nb_spams_periode']  ;
$mails_donnes['quarantaine_periode'] = isset($_POST['quarantaine_periode']) ? $_POST['quarantaine_periode'] :  $mails_donnes['quarantaine_periode']  ;

$mails_donnes['message'] = isset($_POST['content']) ? $_POST['content'] :  $mails_donnes['message']  ;
$mails_donnes['header_text'] = isset($_POST['header_text']) ? $_POST['header_text'] :  $mails_donnes['header_text']  ;
  //=======================================================================================================
         sauve_options();
         sauve_donnes();
//=======================================================================================================
		$infos_message .=  l10n('save_config') ;
}

	$mails_options = explode("," , $conf['mail_superv']);
	$mails_donnes = Get_Datas();

	$rest_mail= $mails_donnes['rest_mail'];  	
 	$rest_spam= $mails_donnes['rest_spam'];  	
    $reste= $mails_donnes['reste'];  	

$quarantaine = ($mails_donnes['quarantaine'] == 'true') ? true : false ;;  	

	 
	
$PHPWG_VERSION=PHPWG_VERSION;

$template->assign(
  					array(
   'check_mailto' => $mails_options[0] == 'on' ? 'checked="checked"' : '' ,
   'check_header_carbons' => $mails_options[1] == 'on' ? 'checked="checked"' : '' ,
   'check_header_text' => $mails_options[2] == 'on' ? 'checked="checked"' : '' ,

   
   	'nb_mails' => $mails_donnes['nb_mails'] ,
   	'date_mail' => "'".date(l10n('formatdate'),$mails_donnes['date_mail'])."'" ,
   	'nb_mails_maxi' => $mails_donnes['nb_mails_maxi'] ,	
	'nb_mails_periode' => "'".$mails_donnes['nb_mails_periode']."'" ,	
 	'time_mails_reste' => "'".int_to_heure( $rest_mail )."'" ,	
	
  	'nb_spams' => $mails_donnes['nb_spams'] ,
	'date_spam' => "'".date(l10n('formatdate'),$mails_donnes['date_spam'])."'" ,
	'nb_spams_maxi' => $mails_donnes['nb_spams_maxi'] ,	
	 'nb_spams_periode' => "'".$mails_donnes['nb_spams_periode']."'" ,
	 'time_spams_reste' => "'".int_to_heure($rest_spam)."'" ,	
	 
	 'quarantaine' => $quarantaine ,
  	'date_quarantaine' => "'".date(l10n('formatdate'),time()+$reste)."'" ,
	'quarantaine_periode' => "'".$mails_donnes['quarantaine_periode']."'" ,
     'reste' => "'".int_to_heure($reste)."'",
 
    'message' => $mails_donnes['message'] ,
	'header_text' => "'".$mails_donnes['header_text']."'" ,
	
 'PHPWG_VERSION' =>	 PHPWG_VERSION ,
	 
	
		 				)
				);	

	$template->set_filenames(array('plugin_admin_content' => realpath(MAIL_SUPERV_PATH . 'admin/mail_superv_admin.tpl')));
		$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
		
 break; 
 
 
// *************************************************************************
//                        TEST                                             |
// *************************************************************************
 
   case 'mail_superv_test':
   
   $mails_donnes = Get_Datas() ;
   
   	$group_id = isset($_POST['group']) ? $_POST['group'] :  '-1'  ;
	if ($group_id >= 0) {
      $query = '
		SELECT
    		name
  		FROM '.GROUPS_TABLE.'
  		WHERE id = '.$group_id.'
		;';
  		list($group_name) = mysql_fetch_row(pwg_query($query));
		}	else {
				$group_name="";		 
		}		
//================================================


	
if ( isset($_POST['test_envoie']) ) {
	
		$mails_donnes['message_test'] = isset($_POST['content']) ? $_POST['content'] :  $mails_donnes['message_test']  ;
		$message=$mails_donnes['message_test'];
		sauve_donnes();
	 	test_envoie($message,$group_name,$group_id);   
		$mails_donnes = Get_Datas() ;
		
  } 

  $groups[-1] = '---------';

  $query = '
    SELECT id, name
		FROM '.GROUPS_TABLE.'
		ORDER BY name ASC
		;';

  $result = pwg_query($query);
//----------------------------------------------------------------	
  while ($row = mysql_fetch_array($result,MYSQL_ASSOC))
  {
    $groups[$row['id']] = $row['name'];
  }
 //--------------------------------------------------------------- 

  $template->assign(
    	'Group',
   		array(
	  		'group_options'=> $groups,
			'selected' => $group_id 
			)
 		);
//=================================================================
$destinataires= implode("<br />",get_liste($group_id));
  $template->assign(
  					array(
				'Groupe'     => $groups,
    			'message_test' => $mails_donnes['message_test'] ,
				'liste' => $destinataires ,

		 				)
				);	
				
   	$template->set_filenames(array('plugin_admin_content' => realpath(MAIL_SUPERV_PATH . 'admin/mail_superv_test.tpl')));
		$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
   break;
// *************************************************************************
//              BLACK LISTE                                         |
// *************************************************************************   
     case 'mail_black_liste':
   		load_language('help/plugin.lang', MAIL_SUPERV_PATH);	
	Global $pays,$region,$ville ;	

		kill_list();
		
	  	$aff_nb=false;
	  	$smile_bonjour=MAIL_SUPERV_PATH."smilies/bonjour.gif" ; 
      	$template->assign(
  					array(
					'smile_bonjour' => $smile_bonjour ,
					)
			);		
			$aff_nb = false;
	 		$liste_bl=array();
	 		$liste_ip=array();

		$ip_black="";
		$info_ip ="";

 		include  (MAIL_SUPERV_PATH.'include/save_info.php'); 
		$ip_black_test = (isset($_POST['ip_black_test'])) ? $_POST['ip_black_test'] : $ip_black ;
      	$mails_options[3] = isset($_POST['NO_MAIL_LIST']) ? $_POST['NO_MAIL_LIST'] : $mails_options[3] ;
      	$mails_options[4] = isset($_POST['NO_CONNECT']) ? $_POST['NO_CONNECT'] : $mails_options[4] ;
	    $mails_options[5] = isset($_POST['NO_CONNECT']) ? $_POST['NO_CONNECT'] : $mails_options[5] ;		
 					
		if ( isset($_POST['submit']) )
		{
			if (  $_POST['submit'] == l10n('Valider') )
      		{
				$mails_options[3] = isset($_POST['NO_MAIL_LIST']) ? $_POST['NO_MAIL_LIST'] : "off" ;
      			$mails_options[4] = isset($_POST['NO_CONNECT']) ? $_POST['NO_CONNECT'] : "off" ;
      			$mails_options[5] = isset($_POST['SET_AUTO']) ? $_POST['SET_AUTO'] : "off" ;
      	
				sauve_options();
			   $infos_message .=  l10n('save_config');   
			   unset ($_POST['submit']);
			}

		} 
		


	$f_action  = $my_base_url.'&amp;tab=mail_black_liste' ;
	$champs_ip=array();
	$champs_bl=array();
	if (!empty($liste_ip))		$champs_ip=array_keys($liste_ip[0]);
	if (!empty($liste_bl))      $champs_bl=array_keys($liste_bl[0]);
	$smile_bonjour=MAIL_SUPERV_PATH."smilies/mouche.gif" ; 
     $template->assign(
  					array(
					    'smile_bonjour' => $smile_bonjour ,
                		'champs_ip' => $champs_ip ,					
						'liste_ip' => $liste_ip,
						'champs_bl' =>  $champs_bl 	 ,	
						'liste_bl' => $liste_bl ,
                 		'conf_admin_layout' => $conf['admin_layout'] ,
						'ip_black' => $ip_black ,
						'IS_SPAM' => test_spam(  $ip_black_test  ),
						'ip_black_test' => (isset($_POST['ip_black_test']) ) ? $_POST['ip_black_test'] : $ip_black ,
						
						'ip_black_len' =>  strlen($ip_black_test)  ,
						'MAIL_SUPERV_PATH' => MAIL_SUPERV_PATH ,

						'F_ACTION' => $f_action ,


						
						'NO_MAIL_LIST' => $mails_options[3] == 'on' ? 'checked="checked"' : '' ,
                        'NO_CONNECT' => $mails_options[4] == 'on' ? 'checked="checked"' : '' ,
						 'SET_AUTO' => $mails_options[5] == 'on' ? 'checked="checked"' : '' ,
						'IP' => $_SERVER['REMOTE_ADDR'],						
						'PAYS' =>  $pays  ,
 		                'VILLE' =>  $ville ,
 		                'REGION' =>  $region ,	
						
		 			)
				);			 
	 //===============================================================	
	 		 
	 	$template->set_filenames(array('plugin_admin_content' => realpath(MAIL_SUPERV_PATH . 'admin/mail_black_liste.tpl')));
		$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
   break; 

// *************************************************************************
//                      AIDE                                               |
// *************************************************************************   
     case 'mail_superv_help':

   load_language('help/plugin.lang', MAIL_SUPERV_PATH);	
 
	  $aff_nb=false;
	  $smile_bonjour=MAIL_SUPERV_PATH."smilies/bonjour.gif" ; 
      $template->assign(
  					array(
					'smile_bonjour' => $smile_bonjour ,
					)
			);		
	$aff_nb = false;
	;
	 
	 	$template->set_filenames(array('plugin_admin_content' => realpath(MAIL_SUPERV_PATH . 'admin/mail_superv_help.tpl')));
		$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
   break; 
 //====================================================================
  }
//================================================================================


	if  ( $mails_donnes['reste'] < 0 ) {
	    $mails_donnes['quarantaine'] =false ;
	    $mails_donnes['date_quarantaine']= time()  ;	
		$mails_donnes['nb_spams'] = 0 ;
	    $modif == true ;
	}
	 
	  
 	$rest_mail =    $mails_donnes['rest_mail'] ;
	if ($rest_mail <=0 || $mails_donnes['nb_mails'] ==0 ){
	   $mails_donnes['nb_mails'] =0 ;
	   $mails_donnes['date_mail'] = time();
	   $modif = true ;
	}
	
	$rest_spam =    $mails_donnes['rest_spam'] ;

 	if ($rest_spam <=0 || $mails_donnes['nb_spams'] ==0 ){
	   $mails_donnes['nb_spams'] =0 ;
	   $mails_donnes['date_spam'] = time();
	   $modif = true ;
	}
	if ( $modif == true ) 	{ 
				sauve_donnes();
 				$modif = false ;
 		}
		if (!isset($infos_message)){
		  $infos_message = "";
		} 
		if ($aff_nb == true) {
		 $infos_message .= 'Mails    : '.$mails_donnes['nb_mails']. '  \\  ' . $mails_donnes['nb_mails_maxi'];
		 $infos_message .= "\n".'Spams : '.$mails_donnes['nb_spams']. '  \\  ' . $mails_donnes['nb_spams_maxi'];
		}
		

		  
		if  ($infos_message != "")  {
		   array_push($page['infos'],  $infos_message);
		 $infos_message="";
		 }
		if (!isset($erreur_message)){
		  $erreur_message = "";
		} 		 
		if  ($erreur_message != "")  {
	
		  array_push($page['errors'], $erreur_message);
		  $erreur_message="";
	
		 
		 }		 
		 
//========================================================================	
	
		 
?>